# stack

A stack of http handlers

## Blog posts

coming soon!

## Examples

 - [vanilla-node][1]
 - [raynos-blog source code][2] Coming soon!

## Documentation

Annotated source code coming soon

### Stack

Stack is the prototype for any stack instance. Either create new stacks or extend it.

[Instantiation and initiliazation of prototypes][3]

### Stack.constructor(...)

Initializes the stack, any function passed in will be passed into the stack.

### Stack.use(cb)

Adds a function to the stack of http handlers.

cb is a stack-style function along the lines of

	(function (re
		q, res) {
		// do things
		// call next http handler in stack
		this.next();
		// test the errors object
		if (this.errors) { ... }
		// send an error to the errors object and call the next http handler
		this.next(err);
		// Add data to the store (this)
		// data is persisted along http handlers in the stack
		this.data = bla
		// take data out of the store (this)
		var data = this.data
	});

### Stack.handle(hash)

Handle a stack. Meaning that we flow data through the stack.

	stack.handle({ data: [req, res] });

The hash is 

	{
 		Array data - an array of data to pass to middlewares
 		Function ceil - a ceiling function for the stack,
 			this will be called first
 		Function floor - a floor function for the stack,
 			this will be called last	
 	}

 This will call every function in the stack with the passed data. 

 ### Stack.express(f)

 Wraps an express-style function so it "works" with stack. This doesn't mean you can port your express app using stack and it will just "work" but provides some level of code re-use with express.

 ### Stack.passErrorsTo(f)

 Generates a callback that you can use to pass any errors to the next function

 	stack.handle({
		data: [res, pathname],
		floor: this.passErrorsTo(this.next)
	});

Useful for calling another stack inside a stack and passing the errors of the inner stack back to the outer stack

### Stack.storeData(hash)

Generates a callback which will invoke an asynchronous function and either pass on the error or store the data.

The hash is

	{
		Function fun - async function to invoke
		Array args - args to invoke function with, the cb
			for the async functions gets appended to the 
			end of args
		String key - key to store data returned from fun
			on this
		Function cb - optional cb, will be called instead 
			of this.next
		Object context - optional context, fun will be 
			called with this context
	}

example:

	function _exists(res, pathname) {
		this.storeData({
			fun: path.exists.bind(path), 
			args: [pathname], 
			key: "exists"
		});
	}

It basically allows you to define pieces of the stack that just grab data from an asynchronous location and store it on this.

  [1]: http://www.github.com/Raynos/vanilla-node
  [2]: http://www.github.com/Raynos/raynos-blog
  [3]: http://raynos.org/blog/7/Doing-Object-Oriented-Javascript---part-3